;*******************************************************************************
;/plugg/ inserre un bloc  la place de points ou autre entit fournies par des gometres/none
;
(pw_pluggin_register '("point2bloc" ( "CIRCLE" "SHAPE" "POINT" "ELLIPSE" "INSERT")("insere un bloc au point d'insertion d'une entit" "-" "Insert a block at the insertion point of an entity")))

(defun point2bloc ( / sel lent l i eg pins blnam )
  (setq sel (ssget "_p"))
  (setq lent (pw_listsel sel))
  (setq i 0)
  (setq blnam (cdr (assoc 2 (entget (car  (entsel (pw_getxt 'PW97 "\nSelectionner le bloc  inserer :")))))))
  (pw_setvar1 "attreq" 0)
  (foreach l lent
    (setq i (+ 1 i))
    (setq eg (entget l))
    (setq pins (PW_scg2scu  (cdr (assoc 10 eg))))
    ;;suivant pour topocad
    ;(command "_insert" "Spotblk1" pins "1" "1" "0"  (itoa i) (rtos (last pins))  )
    (command "_insert" blnam pins "1" "1" "0" (rtos (last pins))  )
   
  )
  (pw_setvar2 "attreq" )

)
;*******************************************************************************
;/plugg/ inserre un bloc  la place de points ou autre entit fournies par des gometres/none
;
(pw_pluggin_register '("select_by_z" ( "CIRCLE" "SHAPE" "POINT" "ELLIPSE" "INSERT")("Selectionne en fonction de l'altitude" "-" "Select according to z value")))

(defun select_by_z ( / sel lent l i eg pins blnam )
  (setq sel (ssget "_p"))
  (pw_getstringmem "\nMinimum z value * for none" "pw-min-z")
  (pw_getstringmem "\nMaximum z value * for none" "pw-max-z")
  (setq lent (pw_listsel sel))
  (setq sel (ssadd))
  (foreach l lent
    (setq eg (entget l))
    (setq z (last (PW_scg2scu  (cdr (assoc 10 eg)))))
    (cond ((= "*" pw-min-z)
	   (if (<= z (read pw-max-z))
	     (setq sel (ssadd l sel))
	   )
	  )
          ((= "*" pw-max-z)
	   (if (>= z (read pw-min-z))
	     (setq sel (ssadd l sel))
	   )
	  )
          (T
	   (if (and (>= z (read pw-min-z))(<= z (read pw-max-z)))
	     (setq sel (ssadd l sel))
	   )
	  )
      )
   
  )
  (sssetfirst sel sel)
)
;*******************************************************************************
;/plugg/ inserre un bloc  la place de points ou autre entit fournies par des gometres/none
;
(pw_pluggin_register '("select_3dface_by_z" ( "3DFACE")("Selectionne des face 3d en fonction de l'altitude" "-" "Select 3d face according to z value")))

(defun select_3dface_by_z ( / sel lent l i eg pins blnam z1 z2 z3 z4 zmin zmax)
  (setq sel (ssget "_p"))
  (pw_getstringmem "\nMinimum z value * for none" "pw-min-z")
  (pw_getstringmem "\nMaximum z value * for none" "pw-max-z")
  (setq lent (pw_listsel sel))
  (setq sel (ssadd))
  (foreach l lent
    (setq eg (entget l))
    (setq z1 (last (PW_scg2scu  (cdr (assoc 10 eg)))))
    (setq z2 (last (PW_scg2scu  (cdr (assoc 11 eg)))))
    (setq z3 (last (PW_scg2scu  (cdr (assoc 12 eg)))))
    (setq z4 (last (PW_scg2scu  (cdr (assoc 13 eg)))))
    (setq zmin (eval (list 'MIN z1 z2 z3 z4)))
    (setq zmax (eval (list 'MAX z1 z2 z3 z4)))    
    (cond ((= "*" pw-min-z)
	   (if (<= zmax (read pw-max-z))
	     (setq sel (ssadd l sel))
	   )
	  )
          ((= "*" pw-max-z)
	   (if (>= zmin (read pw-min-z))
	     (setq sel (ssadd l sel))
	   )
	  )
          (T
	   (if (and (>= zmin (read pw-min-z))(<= zmax (read pw-max-z)))
	     (setq sel (ssadd l sel))
	   )
	  )
      )
   
  )
  (sssetfirst sel sel)
)

;*******************************************************************************
;/plugg/ insere un bloc  la mme place qu'un autre bloc/none
;permet gale ment de conserver le calque et l'angle de rotation
;
(pw_pluggin_register '("bloc2another_bloc" ( "CIRCLE" "SHAPE" "POINT" "ELLIPSE" "INSERT")("insere un bloc  la mme place qu'un autre bloc" "permet gale ment de conserver le calque et l'angle de rotation" "Insert  bloc at the insertion point of an other bloc")))

(defun bloc2another_bloc ( / sel lent l i eg pins blnam )
  (setq sel (ssget "_p"))
  (setq lent (pw_listsel sel))
  (setq i 0)
  (setq blnam (cdr (assoc 2 (entget (car  (entsel (pw_getxt 'PW97 "\nSelectionner le bloc  inserer :")))))))
  (pw_setvar1 "attreq" 0)
  (foreach l lent
    (setq i (+ 1 i))
    (setq eg (entget l))
    (setq pins (PW_scg2scu  (cdr (assoc 10 eg))))
    (setq aro (pw_to_aunits (cdr (assoc 50 eg))))
    (setq calq (cdr (assoc 8 eg)))
    (setvar "clayer" calq)
    ;;suivant pour topocad
    (command "_insert" blnam pins "1" "1" aro   )
   
  )
  (pw_setvar2 "attreq" )

)

; ****************************************************************************
;;/topo/ inserre un bloc  la place de textes fournies par des gometres a la valeur z du texte/none
;
(pw_pluggin_register '("inspoint2blocfromzvalue" (  "TEXT") ("insere un bloc  la place du texte d'altitude" "fournie par les gometres a la valeur z du texte" "Insert a bloc at insertion point of an altimetric text")))
(defun inspoint2blocfromzvalue ( /  sel lent i en  l eng modif z)

  (setq sel (ssget "_p"))
  (setq lent (pw_listsel sel))
  (setq i 0)
  (setq blnam (cdr (assoc 2 (entget (car  (entsel (pw_getxt 'PW97 "\nSelectionner le bloc  inserer :")))))))
  (pw_setvar1 "attreq" 0)
  (foreach l lent
    (setq i (+ 1 i))
    (setq eg (entget l))
    (if (numberp (setq z (read (cdr (assoc 1 eg)))))
      (progn
	(setq pins (PW_scg2scu  (cdr (assoc 10 eg))))
	(setq pins (list (car pins) (cadr pins) z))
	;;suivant pour topocad
	;(command "_insert" "Spotblk1" pins "1" "1" "0"  (itoa i) (rtos (last pins))  )
	(command "_insert" blnam pins "1" "1" "0" (rtos (last pins))  )
       )
   )
   
  )
  (pw_setvar2 "attreq" )
)

;*******************************************************************************
;/plugg/ inserre un point au point d'insertion/none
;
(pw_pluggin_register '("point_at_insertion" ( "TEXT" "SHAPE" "MTEXT"  "INSERT")( "insere un point au point d'insertion" "Draw a nodal at the insertion point")))

(defun point_at_insertion ( / sel lent l i eg pins  )
  (setq sel (ssget "_p"))
  (setq lent (pw_listsel sel))
  (setq i 0)
  (pw_setvar1 "attreq" 0)
  (foreach l lent
    (setq i (+ 1 i))
    (setq eg (entget l))
    (setq pins (PW_scg2scu  (cdr (assoc 10 eg))))
    (command "_point"  pins  )
   
  )
  (pw_setvar2 "attreq" )

); ****************************************************************************
;;/plugg/ lance une edition globale faon attedit/none
;
(pw_pluggin_register '("global_attribut_edition" ( "INSERT" )(" lance une edition globale des attribut faon attedit" "Automatization of ATTEDIT command on a selection set" )))

(DEFUN global_attribut_edition ( / pr etiq bl  ent cd nouv dx dy)
 
 (setq pr (pw_ch_choix "\n Choisissez la proprit a changer :" "Valeur Angle Style Hauteur Calque cOuleur Position Inclinaison" "Valeur" ))
 (setq etiq (strcase (getstring "\nEtiquette de l'attribut ?<*>")))
 (if (= "" etiq)
   (setq etiq "*")
 )
 (cond  ((= "VALEUR" pr)
	 (setq nouv (getstring 't "\nValeur de remplacement :"))
	 (setq cd 1)
	)
        ((= "ANGLE" pr)(setq nouv (+ pw-ucsbase (pw_to_rad (getreal "\nNouvel angle (dans le SCU):" ))))
	 (setq cd 50)
	 )
         ((= "INCLINAISON" pr)(setq nouv (pw_to_rad (getreal "\nNouvel inclinaison :" )))
	 (setq cd 51)
	 )
       ((= "STYLE" pr)(setq nouv (getstring "\nNouveau style :"))
	 (setq cd 7)
	 )
        ((= "HAUTEUR" pr)(setq nouv (getreal "\nNouvelle Hauteur de texte :"))
	 (setq cd 40)
	 )
        ((= "CALQUE" pr)(setq nouv (getstring "\nNouveau calque :"))
	 (setq cd 8)
	 )
        ((= "COULEUR" pr)(setq nouv (getint "\nNouvelle Couleur :"))
	 (setq cd 62)
	 )
        ((= "POSITION" pr)
	 (setq dx (getreal "\nDeplacement en x"))
	 (setq dy (getreal "\nDeplacement en y"))
	 (setq cd 11)
	)
 )
  ;-----------------------------------------------------------
  (defun modif ( ent cd nouv / tmp tp fin prop1)
    (while (not fin)
      (setq tp (cdr (assoc 0 (setq eg (entget ent)))))
      (if (=	"ATTRIB" tp )
	
	(if (and (not (equal (setq tmp (assoc cd eg)) (cons cd nouv)))(wcmatch (strcase (cdr (assoc 2 eg))) etiq))
	  (progn
	    (setq eg  (pw_subst_ou_aj cd nouv eg))
	    (entmod eg)
	    (entupd ent)
	    )
	  )
	)
      (if (=	"SEQEND" tp )
	(setq fin 't)
	)
      (setq ent (entnext ent))
      
      )
    )
  ;-----------------------------------------------------------
  (defun modifpos ( ent cd dx dy / tmp tp fin prop1 np)
    (while (not fin)
      (setq tp (cdr (assoc 0 (setq eg (entget ent)))))
      (if (=	"ATTRIB" tp )
	
	(if (and (setq prop1 (assoc cd eg) )(wcmatch (strcase (cdr (assoc 2 eg))) etiq))
	  (progn
	    (setq np (pw_prp (cdr prop1) dx dy))
	    (setq eg (subst (cons cd np) prop1 eg))
	    (entmod eg)
	    (entupd ent)
	    )
	  )
	)
      (if (= "SEQEND" tp )
	(setq fin 't)
	)
      (setq ent (entnext ent))
      
      )
    )
  ;-----------------------------------------------------------

	 (pw_setvar1 "cmdecho" 0)
	 (setq sel (pw_listsel (ssget "_p" '((66 . 1)))))
	 
	 (foreach en sel
	   (cond ((= "POSITION" pr)
		  ( modifpos en cd dx dy)
		  )
		 ('t
		  ( modif en cd nouv)
		 )
		)
	   )
)

; ****************************************************************************
;;/plugg/  dfinit les attributs sur le mme calque que le bloc/none
; ce qui permet de recuperer des blocs ayant eu des attributs definis sur un autre calque que 0
;
(pw_pluggin_register '( "attrib2samelayer" ( "INSERT" )("dfinit les attributs sur le mme calque que le bloc" "PLace attribs on the same layer than the insert they belong to")))

(defun attrib2samelayer ( / fin eg ent tp tmp sel  lblsel l)

 (defun modif ( ent / tmp tp )
  (setq fin nil)
  (while (not fin)
    (setq tp (cdr (assoc 0 (setq eg (entget ent)))))

    (if (= "INSERT" tp )
     (setq pl (cdr (assoc 8 eg)))
    )

    (if (= "ATTRIB" tp )

	(if (not (equal (setq tmp (assoc 8 eg)) '(8 . "0")))
	 (progn
	  (setq eg (subst (cons 8  pl)	tmp eg))
	  (entmod eg)
	  (entupd ent)
	 )
	)
     )
     (if (=	"SEQEND" tp )
	  (setq fin 't)
     )
       (setq ent (entnext ent))
	
  )
 )

 (setq sel (ssget "_p"))
 (setq lblsel (pw_LISTSEL sel))
 (foreach l lblsel
  (if	 (= (cdr (assoc 66 (entget l))) 1 )
	(modif l)
  )
 )
)
; ****************************************************************************
;;/plugg/ Change l'epaisseur et le style de trac des attributs/none
; la proprit cible est choisie  partir d'un modle
;
(pw_pluggin_register '("change_pstyle" ( "INSERT" )("Change l'epaisseur et le style de trac des attributs" "Change attribs width and plot style")))

(defun change_pstyle ( / eg tmp380 sel blsel lblsel eplist cd l eng pltlist)

 (defun modif ( ent / tmp tp )
  (setq fin nil)
  (while (not fin)
    (setq tp (cdr (assoc 0 (setq eg (entget ent)))))
    (if (="ATTRIB" tp )
	 (progn
	  (setq tmp370 (assoc 370 eg))
	  (if (setq tmp380 (assoc 380 eg))
	    nil
	    (setq tmp390 (assoc 390 eg))
	  )
	  (setq eg (subst eplist tmp370 eg))
	  (if tmp380
 	   (setq eg (subst pltlist tmp380 eg))
	   (setq eg (subst pltlist tmp390 eg))
	  )
	 
	 (entmod eg)
	 (entupd ent)
	)
     )
     (if (= "SEQEND" tp )
	  (setq fin 't)
     )
       (setq ent (entnext ent))
	
  )
 )


 (setq blsel (ssget "P"))
 (setq lblsel (pw_LISTSEL blsel))
 (setq eng (entget (car (nentsel (pw_getxt 'PW100 "\Choisissez un objet de reference pour epaiseur et style de trac :")))))
 (setq eplist (assoc 370 eng))
 (if (setq pltlist (assoc 390 eng))
   (setq cd 390)
   (setq pltlist (assoc 380 eng) cd 380)
 )
 (foreach l lblsel
  (if (= (cdr (assoc 66 (entget l))) 1 )
	(modif l)
  )
 )
)


; ****************************************************************************
;;/plugg/ change la hauteur d'un bloc a partir de la valeur d'une de ses etiquettes/none
; l'ettiquette source est choisie  partir d'un modle
;
(pw_pluggin_register '("change_Z_from_attrib" ( "INSERT" )("change la hauteur d'un bloc a partir de la valeur d'une de ses etiquettes" "Change z insertion point according to an attrib value")))

(defun change_Z_from_attrib ( / eg  sel  lblsel etiq lch l eng modif z)

 (defun modif ( ent / tmp pins eg  )
    (setq pins (cdr (setq tmp (assoc 10 (setq eg (entget ent))))))
    (setq pins (append (pw_pt_2d pins) (list z)))
    (setq eg (subst (cons 10 pins) tmp eg))
    (entmod eg)
 )


 (setq sel (ssget "P"))
 (setq lblsel (pw_LISTSEL sel))
 (pw_setvar1 "ATTMODE" 2)
 (command "_REGEN")
  (while (not (setq nesel (nentsel "\nChose reference attribute for z coordinate :")))
  )
 (setq eng (entget (car nesel)))
 (setq etiq (cdr (assoc 2 eng)))
 (foreach l lblsel
  (if (setq z (pw_refbloc l etiq))
   (if (numberp (read z)) ;;est un nombre directement
    (setq z (read z))
     (if (/= z "")
	   (progn
	    (setq lch (pw_sep_ch_nomb z))
	     (if (< 1 (length lch))  ;;contient nombre et chaine ex : "Alt 125.36"
	      (if (not (numberp (setq z (read (car lch)))))      ;;recherche le 1er nombre de la liste, qui ne peut tre qu'en 1re ou 2 eme POS
		 (setq z (read (cadr lch)))
	      )
	      (if (not (numberp (setq z (read (car lch)))))
	       (progn
		 (prompt "\nAttribute does not contain any Z")
		 (setq z nil)
	       )
	     )
	    )
	   )
       (setq z nil)
      )
    )
   )
  (if z
      (modif l)
  )
 )
 (pw_setvar2 "ATTMODE" )
 (command "_REGEN")  
)
; ****************************************************************************
;;/plugg/ change la hauteur d'un bloc a partir de la valeur d'une de ses etiquettes/none
; l'ettiquette source est choisie  partir d'un modle
;
(pw_pluggin_register '("select_by_attrib" ( "INSERT" )("Selectionne un bloc a partir de la valeur d'une de ses etiquettes" "select insert according to their attrib value")))

(defun select_by_attrib ( / eg  sel  lblsel etiq lch l eng z sel2 nesel)
 (setq sel (ssget "P"))
 (setq lblsel (pw_LISTSEL sel))
 (pw_setvar1 "ATTMODE" 2)
 (command "_REGEN")
 (while (not (setq nesel (nentsel "\Chose reference attribute for selection :")))
  )

 (setq eng (entget (car nesel)))
 (pw_getstringmem "\nSelection string ?(# @ * ? [ ] are pattern)" "pw-sel-string")
 (setq etiq (cdr (assoc 2 eng)))
 (setq sel2 (ssadd))
 (foreach l lblsel
  (if (setq z (pw_refbloc l etiq))
   (if (wcmatch z  pw-sel-string)
    (setq sel2 (ssadd l sel2))
   )
  )
 )
 (pw_setvar2 "ATTMODE" )
 (command "_REGEN")
 (sssetfirst sel2 sel2)
)
; ****************************************************************************
;;/plugg/ place la valeur z  zro des blocs/none
; 
;
(pw_pluggin_register '("change_Z_to_zero" ( "INSERT" )("Place un bloc  l'altitude zro" "Place insert to z coord 0")))

(defun change_Z_to_zero ( / eg  sel  lblsel  l eng modif z)

 (defun modif ( ent / tmp pins eg  )
    (setq pins (cdr (setq tmp (assoc 10 (setq eg (entget ent))))))
    (setq pins (append (pw_pt_2d pins) (list z)))
    (setq eg (subst (cons 10 pins) tmp eg))
    (entmod eg)
 )

 (setq sel (ssget "P"))
 (setq lblsel (pw_LISTSEL sel))
 (setq z 0)
 (foreach l lblsel
    (modif l)
 )
)

; ****************************************************************************
;;/topo/ change la hauteur d'un element partir de la valeur z du texte  cot/none
;
(defun c:change_Z_from_text ( /  en  l eng modif z)

 (defun modif ( ent / tmp pins eg  )
    (setq pins (cdr (setq tmp (assoc 10 (setq eg (entget ent))))))
    (setq pins (append (pw_pt_2d pins) (list z)))
    (setq eg (subst (cons 10 pins) tmp eg))
    (entmod eg)
 )


 (while (setq en (car (entsel "\nChose reference text for z coordinate :")))
  (setq eng (entget en))
  (setq z (read (cdr (assoc 1 eng))))

   (if (numberp z)
    (modif (setq en (car (entsel "\nChoose the insert to change z coordinate "))))
   ) 
 )
)


; ****************************************************************************
;;/plugg/ change l'etiquette z d'un bloc a partir de sa hauteur/none
; l'etiquette source est choisie  partir d'un modle
;
(pw_pluggin_register '("change_attrib_from_z" ( "INSERT" )("change l'etiquette z d'un bloc a partir de sa hauteur" "Change attrib value according to insert's z coord")))

(defun change_attrib_from_z ( /  sel  lblsel etiq lch l eng z nesel) 
 (setq sel (ssget "P"))
 (setq lblsel (pw_LISTSEL sel))
 (pw_setvar1 "ATTMODE" 2)
 (command "_REGEN")
 (while (not (setq nesel (nentsel "\Choose target attrib for z coordinate :")))
  )
 (setq eng (entget (car nesel)))
 (setq etiq (cdr (assoc 2 eng)))
 (foreach l lblsel
    (setq pins (cdr (setq tmp (assoc 10 (setq eg (entget l))))))
    (setq z (rtos (last pins)))
    (pw_mdf1att l etiq z)
 )
 (pw_setvar2 "ATTMODE" )
 (command "_REGEN")    
)
; ****************************************************************************
;;/plugg/applique un changement de numerotation par addition ou soustraction/none
; l'ettiquette source est choisie  partir d'un modle
;
(pw_pluggin_register '("retranche_une_valeur" ( "INSERT" ) ("Applique une addition ou soustraction  un attribut" "L'attribut doit tre numrique" "Apply addition or substract to attrib value")))

(defun retranche_une_valeur ( /  sel  lblsel etiq lch l eng z nbd nbd1 prec)
 (setq prec (getvar "LUPREC"));;precision souhaite
 (setq sel (ssget "P"))
 (setq lblsel (pw_LISTSEL sel))
 (setq eng (entget (car (nentsel "\Choisissez l'attribut cible pour operation:"))))
 (setq op (read (getstring "\nAddition +, soustraction - ?")))
 (setq val (getreal "\nde combien?"))
 ;(setq nbd1 (PW_NBDIGIT val));;precision de la valeur retranche
 (setq etiq (cdr (assoc 2 eng)))
 (foreach l lblsel
    (setq z (read (pw_refbloc l etiq)))
    (if (numberp z)
     (progn
      ;(setq nbd (PW_NBDIGIT z));;precision de la valeur modifie
      ;(setq nbd (max nbd nbd1))
      (setq z (eval (list op z val)))
;      (pw_mdf1att l etiq (rtos  z 2 nbd))
      (pw_mdf1att l etiq (rtos z 2 prec))
     )
    )
 )
)



;*******************************************************************************
;/plugg/exporte un bloc au format numero x y z/none
;
(pw_pluggin_register '( "export_NXYZ" (  "INSERT") ("Exporte les blocs au format numero x y z" "dans un fichier texte" "remplace les . par des , " "export in a text file in format : number xcoord ycoord zcoord" )))

(defun export_NXYZ ( / sel lent l i eg eng fscr etiq num  f ch nesel)
  (setq sel (ssget "_p"))
  (setq lent (pw_listsel sel))
  (setq i 0)
  (if (setq fscr (getfiled "Nom du rapport - name of the report:" "" "xyz" 1))
   (progn
    (setq f (open fscr "w"))
     (while (not (setq nesel (nentsel (pw_getxt 'PW82 "\nChoisissez l'attribut de numro :"))))
  )

  (setq eng (entget (car nesel)))
  (setq etiq (cdr (assoc 2 eng)))
  (foreach l lent
    (if (setq num (pw_refbloc l etiq))
     (progn
    (setq eg (entget l))
    (setq ch (pw_ch_de_lst  (mapcar 'rtos  (cdr (assoc 10 eg))) " "))
    (setq ch (pw_str_subst_all "," "." ch))
    (setq ch (strcat num " " ch))
    (write-line ch f)
    )
    (prompt "\nBloc sans matricule - Block without tag")
   )
  )
    (close f)
  )
  )

)

;*******************************************************************************
;/plugg/exporte les attributs d'un bloc au format excel csv/none
;
(pw_pluggin_register '("export_excel_csv" (  "INSERT") ("exporte les attributs d'un bloc au format excel csv" "dans un fichier texte (spar par des virgules)" "Export attribs value to the excel csv format" )))

(defun export_excel_csv ( / sel lent l i 1st fscr  intitule  f ch )
  (setq sel (ssget "_p"))
  (setq lent (reverse (pw_listsel sel)))
  (setq i 0)
  (if (setq fscr (getfiled "Nom du rapport - name of the report :" "" "csv" 1))
   (progn
    (setq f (open fscr "w"))
    (setq 1st (car lent))
    ;;ecrit l'entete avec les etiquettes d'attribut
    (setq intitule (pw_ch_de_lst (mapcar 'car (pw_ext_l_att 1st )) ","))
    (write-line intitule f)    
    (foreach l lent
     (setq ch (pw_ch_de_lst (mapcar 'cdr (pw_ext_l_att l )) ","))
     (write-line ch f)
    )
    (close f)
   )
  )
)

;*******************************************************************************
;;/plugg/Deplace un bloc selon son angle - move an insert according to its rotation angle/none
;; register this plug-in for both linear and nodal entities that have a 10 code
(pw_pluggin_register '("move_relative_to_angle" ("INSERT" "SHAPE" "TEXT" "MTEXT")
						("Deplace un bloc selon son angle" " - " "move an insert according to its rotation angle")
					 )
)
;;definition de la commande - function definition
(defun move_relative_to_angle ( / sell l eg pb pd ddep adep aro )
 (prompt (pw_getxt 'PW95 "\nAttention le scu doit tre gnral !"))
 (setq pb (getpoint (pw_getxt 'PW185 "\nPoint de base de dplacement")))
 (setq pd (getpoint pb (pw_getxt 'PW136 "\nSecond point de dplacement")))
 ;;(setq vdep (pw_p1-p2 pd pb))
 (setq ddep (distance pb pd))
 (setq adep (angle pb pd))
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))
 (foreach l sell
  (setq eg (entget l))
   (progn
    (setq aro (cdr (assoc 50 eg)))
    (setq pb (cdr (setq tmp (assoc 10 eg))))
    (setq aro (+ adep aro))
    (setq pd (polar pb aro ddep))
    (setq eg (subst (cons 10 pd) tmp eg))
    (entmod eg)
   )
 )
)
